import { lookupCambridge, capitalize } from './helper.js';

chrome.runtime.onInstalled.addListener(function (details) {
  // if(details.reason == "install"){
  //   chrome.storage.local.set({ dictionary: 'english' }, () => {});
  // }
  // else if(details.reason == "update"){
  //   chrome.storage.local.set({ dictionary: 'english' }, () => {});
  // }
  chrome.storage.local.get(['dictionary'], function (result) {
    chrome.storage.local.set({ dictionary: 'english' }, () => {});
    chrome.contextMenus.create({
      id: 'cambridge-dictionary',
      title: `Cambridge Dictionary (${capitalize(result.dictionary)}): '%s' `,
      contexts: ['selection'],
    });
  });

  // Create lookup history 
  chrome.storage.local.get(['cambridge-history'], function (result) {
    if (!result["cambridge-history"]) {
      chrome.storage.local.set(
        {
          "cambridge-history": [],
        },
        () => {
          console.log("Created cambridge-history");
        }
      );
    }
  });
});

chrome.contextMenus.onClicked.addListener(function (info) {
  const selectionText = info.selectionText;
  chrome.storage.local.get(['dictionary'], function (result) {
    if (result.dictionary) {
      lookupCambridge(selectionText, result.dictionary);
    }
  });

  // Add to history 
  chrome.storage.local.get(["cambridge-history"], function (result) {
    const list = result["cambridge-history"];
    if (list.includes(selectionText)) return;
    chrome.storage.local.set(
      {
        "cambridge-history": list.length < 20 ? [selectionText, ...list] : (list.pop(), [selectionText, ...list]),
      },
      () => {
        console.log(list);
      }
    );
  });
});

chrome.storage.onChanged.addListener(function(changes, namespace) {
  if ("dictionary" in changes) {
    chrome.contextMenus.update('cambridge-dictionary', {
      title: `Cambridge Dictionary (${capitalize(changes.dictionary.newValue)}): '%s' `,
    });
  }
});
